Index: drivers/usb/serial/usb-serial.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/serial/usb-serial.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/serial/usb-serial.h	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/serial/usb-serial.h	4 Aug 2004 01:29:55 -0000	1.2
@@ -1,7 +1,7 @@
 /*
  * USB Serial Converter driver
  *
- *	Copyright (C) 1999 - 2002
+ *	Copyright (C) 1999 - 2003
  *	    Greg Kroah-Hartman (greg@kroah.com)
  *
  *	This program is free software; you can redistribute it and/or modify
@@ -67,7 +67,7 @@
  * usb_serial_port: structure for the specific ports of a device.
  * @magic: magic number for internal validity of this pointer.
  * @serial: pointer back to the struct usb_serial owner of this port.
- * @tty: pointer to the coresponding tty for this port.
+ * @tty: pointer to the corresponding tty for this port.
  * @number: the number of the port (the minor number).
  * @interrupt_in_buffer: pointer to the interrupt in buffer for this port.
  * @interrupt_in_urb: pointer to the interrupt in struct urb for this port.
@@ -118,6 +118,16 @@
 	struct semaphore	sem;
 	void *			private;
 };
+/* get and set the port private data pointer helper functions */
+static inline void *usb_get_serial_port_data (struct usb_serial_port *port)
+{
+	return port->private;
+}
+
+static inline void usb_set_serial_port_data (struct usb_serial_port *port, void *data)
+{
+	port->private = data;
+}
 
 /**
  * usb_serial - structure used by the usb-serial core for a device
@@ -156,6 +166,16 @@
 
 #define NUM_DONT_CARE	(-1)
 
+/* get and set the serial private data pointer helper functions */
+static inline void *usb_get_serial_data (struct usb_serial *serial)
+{
+	return serial->private;
+}
+
+static inline void usb_set_serial_data (struct usb_serial *serial, void *data)
+{
+	serial->private = data;
+}
 
 /**
  * usb_serial_device_type - a structure that defines a usb serial device
@@ -292,7 +312,7 @@
 	if (!port || 
 		port_paranoia_check (port, function) ||
 		serial_paranoia_check (port->serial, function)) {
-		/* then say that we dont have a valid usb_serial thing, which will
+		/* then say that we don't have a valid usb_serial thing, which will
 		 * end up genrating -ENODEV return values */ 
 		return NULL;
 	}
@@ -318,7 +338,7 @@
 
 /* Use our own dbg macro */
 #undef dbg
-#define dbg(format, arg...) do { if (debug) printk(KERN_DEBUG __FILE__ ": " format "\n" , ## arg); } while (0)
+#define dbg(format, arg...) do { if (debug) printk(KERN_DEBUG "%s: " format "\n" , __FILE__ , ## arg); } while (0)
 
 
 
Index: drivers/usb/serial/usbserial.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/serial/usbserial.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/serial/usbserial.c	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/serial/usbserial.c	4 Aug 2004 01:29:56 -0000	1.2
@@ -2,8 +2,8 @@
  * USB Serial Converter driver
  *
  * Copyright (C) 1999 - 2002 Greg Kroah-Hartman (greg@kroah.com)
- * Copyright (c) 2000 Peter Berger (pberger@brimson.com)
- * Copyright (c) 2000 Al Borchers (borchers@steinerpoint.com)
+ * Copyright (C) 2000 Peter Berger (pberger@brimson.com)
+ * Copyright (C) 2000 Al Borchers (borchers@steinerpoint.com)
  *
  *	This program is free software; you can redistribute it and/or
  *	modify it under the terms of the GNU General Public License version
@@ -556,6 +556,10 @@
 		else
 			generic_close(port, filp);
 		port->open_count = 0;
+		if (port->tty) {
+			port->tty->driver_data = NULL;
+			port->tty = NULL;
+		}
 	}
 
 	if (port->serial->type->owner)
@@ -1400,12 +1404,9 @@
 		for (i = 0; i < serial->num_ports; ++i) {
 			port = &serial->port[i];
 			down (&port->sem);
-			if (port->tty != NULL) {
-				while (port->open_count > 0) {
+			if (port->tty != NULL)
+				while (port->open_count > 0)
 					__serial_close(port, NULL);
-				}
-				port->tty->driver_data = NULL;
-			}
 			up (&port->sem);
 		}
 
Index: drivers/usb/serial/visor.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/serial/visor.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/serial/visor.c	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/serial/visor.c	4 Aug 2004 01:29:56 -0000	1.2
@@ -12,6 +12,10 @@
  *
  * See Documentation/usb/usb-serial.txt for more information on using this driver
  *
+ * (06/03/2003) Judd Montgomery <judd at jpilot.org>
+ *	Added support for module parameter options for untested/unknown
+ *	devices.
+ *
  * (03/09/2003) gkh
  *	Added support for the Sony Clie NZ90V device.  Thanks to Martin Brachtl
  *	<brachtl@redgrep.cz> for the information.
@@ -182,10 +186,16 @@
 static int  clie_3_5_startup	(struct usb_serial *serial);
 static void treo_attach		(struct usb_serial *serial);
 
+/* Parameters that may be passed into the module. */
+static int vendor = -1;
+static int product = -1;
+static int param_register;
+
 
 static struct usb_device_id id_table [] = {
 	{ USB_DEVICE(HANDSPRING_VENDOR_ID, HANDSPRING_VISOR_ID) },
 	{ USB_DEVICE(HANDSPRING_VENDOR_ID, HANDSPRING_TREO_ID) },
+	{ USB_DEVICE(HANDSPRING_VENDOR_ID, HANDSPRING_TREO600_ID) },
 	{ USB_DEVICE(PALM_VENDOR_ID, PALM_M500_ID) },
 	{ USB_DEVICE(PALM_VENDOR_ID, PALM_M505_ID) },
 	{ USB_DEVICE(PALM_VENDOR_ID, PALM_M515_ID) },
@@ -201,7 +211,11 @@
 	{ USB_DEVICE(SONY_VENDOR_ID, SONY_CLIE_4_1_ID) },
 	{ USB_DEVICE(SONY_VENDOR_ID, SONY_CLIE_NX60_ID) },
 	{ USB_DEVICE(SONY_VENDOR_ID, SONY_CLIE_NZ90V_ID) },
+	{ USB_DEVICE(SONY_VENDOR_ID, SONY_CLIE_UX50_ID) },
+	{ USB_DEVICE(SONY_VENDOR_ID, SONY_CLIE_TJ25_ID) },
 	{ USB_DEVICE(SAMSUNG_VENDOR_ID, SAMSUNG_SCH_I330_ID) },
+	{ USB_DEVICE(GARMIN_VENDOR_ID, GARMIN_IQUE_3600_ID) },
+	{ USB_DEVICE(ACEECA_VENDOR_ID, ACEECA_MEZ1000_ID) },
 	{ }					/* Terminating entry */
 };
 
@@ -213,6 +227,7 @@
 static __devinitdata struct usb_device_id id_table_combined [] = {
 	{ USB_DEVICE(HANDSPRING_VENDOR_ID, HANDSPRING_VISOR_ID) },
 	{ USB_DEVICE(HANDSPRING_VENDOR_ID, HANDSPRING_TREO_ID) },
+	{ USB_DEVICE(HANDSPRING_VENDOR_ID, HANDSPRING_TREO600_ID) },
 	{ USB_DEVICE(PALM_VENDOR_ID, PALM_M500_ID) },
 	{ USB_DEVICE(PALM_VENDOR_ID, PALM_M505_ID) },
 	{ USB_DEVICE(PALM_VENDOR_ID, PALM_M515_ID) },
@@ -229,7 +244,17 @@
 	{ USB_DEVICE(SONY_VENDOR_ID, SONY_CLIE_4_1_ID) },
 	{ USB_DEVICE(SONY_VENDOR_ID, SONY_CLIE_NX60_ID) },
 	{ USB_DEVICE(SONY_VENDOR_ID, SONY_CLIE_NZ90V_ID) },
+	{ USB_DEVICE(SONY_VENDOR_ID, SONY_CLIE_UX50_ID) },
+	{ USB_DEVICE(SONY_VENDOR_ID, SONY_CLIE_TJ25_ID) },
 	{ USB_DEVICE(SAMSUNG_VENDOR_ID, SAMSUNG_SCH_I330_ID) },
+	{ USB_DEVICE(GARMIN_VENDOR_ID, GARMIN_IQUE_3600_ID) },
+	{ USB_DEVICE(ACEECA_VENDOR_ID, ACEECA_MEZ1000_ID) },
+	{ }					/* Terminating entry */
+};
+
+/* For passed in parameters */
+static struct usb_device_id id_param_table [] = {
+	{ },
 	{ }					/* Terminating entry */
 };
 
@@ -285,6 +310,34 @@
 	.read_bulk_callback =	visor_read_bulk_callback,
 };
 
+/* This structure is for Handspring Visor, and Palm 4.0 devices that are not
+ * compiled into the kernel, but can be passed in when the module is loaded.
+ * This will allow the visor driver to work with new Vendor and Device IDs
+ * without recompiling the driver.
+ */
+static struct usb_serial_device_type param_device = {
+	.owner =		THIS_MODULE,
+	.name =			"user specified device with Palm 4.x protocols",
+	.id_table =		id_param_table,
+	.num_interrupt_in =	NUM_DONT_CARE,
+	.num_bulk_in =		2,
+	.num_bulk_out =		2,
+	.num_ports =		2,
+	.open =			visor_open,
+	.close =		visor_close,
+	.throttle =		visor_throttle,
+	.unthrottle =		visor_unthrottle,
+	.startup =		visor_startup,
+	.shutdown =		visor_shutdown,
+	.ioctl =		visor_ioctl,
+	.set_termios =		visor_set_termios,
+	.write =		visor_write,
+	.write_room =		visor_write_room,
+	.chars_in_buffer =	visor_chars_in_buffer,
+	.write_bulk_callback =	visor_write_bulk_callback,
+	.read_bulk_callback =	visor_read_bulk_callback,
+	.read_int_callback =	visor_read_int_callback,
+};
 
 #define NUM_URBS			24
 #define URB_TRANSFER_BUFFER_SIZE	768
@@ -925,6 +978,19 @@
 	struct urb *urb;
 	int i;
 
+	/* Only if parameters were passed to us */
+	if ((vendor > 0) && (product > 0)) {
+       		struct usb_device_id usb_dev_temp[]=
+	       		{{USB_DEVICE(vendor, product)}};
+		id_param_table[0] = usb_dev_temp[0];
+		info("Untested USB device specified at time of module insertion");
+		info("Warning: This is not guaranteed to work");
+		info("Using a newer kernel is preferred to this method");
+		info("Adding Palm OS protocol 4.x support for unknown device: 0x%x/0x%x",
+			param_device.id_table[0].idVendor, param_device.id_table[0].idProduct);
+		param_register = 1;
+		usb_serial_register (&param_device);
+	}
 	usb_serial_register (&handspring_device);
 	usb_serial_register (&clie_3_5_device);
 	
@@ -957,6 +1023,10 @@
 	int i;
 	unsigned long flags;
 
+	if (param_register) {
+		param_register = 0;
+		usb_serial_deregister (&param_device);
+	}
 	usb_serial_deregister (&handspring_device);
 	usb_serial_deregister (&clie_3_5_device);
 
@@ -987,15 +1057,7 @@
 
 MODULE_PARM(debug, "i");
 MODULE_PARM_DESC(debug, "Debug enabled or not");
-
-
-
-
-
-
-
-
-
-
-
-
+MODULE_PARM(vendor, "i");
+MODULE_PARM_DESC(vendor, "User specified vendor ID");
+MODULE_PARM(product, "i");
+MODULE_PARM_DESC(product, "User specified product ID");
Index: drivers/usb/serial/visor.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/serial/visor.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/serial/visor.h	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/serial/visor.h	4 Aug 2004 01:29:56 -0000	1.2
@@ -20,6 +20,7 @@
 #define HANDSPRING_VENDOR_ID		0x082d
 #define HANDSPRING_VISOR_ID		0x0100
 #define HANDSPRING_TREO_ID		0x0200
+#define HANDSPRING_TREO600_ID		0x0300
 
 #define PALM_VENDOR_ID			0x0830
 #define PALM_M500_ID			0x0001
@@ -40,10 +41,18 @@
 #define SONY_CLIE_4_1_ID		0x009A
 #define SONY_CLIE_NX60_ID		0x00DA
 #define SONY_CLIE_NZ90V_ID		0x00E9
+#define SONY_CLIE_UX50_ID		0x0144
+#define SONY_CLIE_TJ25_ID		0x0169
 
 #define SAMSUNG_VENDOR_ID		0x04E8
 #define SAMSUNG_SCH_I330_ID		0x8001
 
+#define GARMIN_VENDOR_ID		0x091E
+#define GARMIN_IQUE_3600_ID		0x0004
+
+#define ACEECA_VENDOR_ID		0x4766
+#define ACEECA_MEZ1000_ID		0x0001
+
 /****************************************************************************
  * Handspring Visor Vendor specific request codes (bRequest values)
  * A big thank you to Handspring for providing the following information.
Index: drivers/usb/serial/xircom_pgs.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/serial/xircom_pgs.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/serial/xircom_pgs.S	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/serial/xircom_pgs.S	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,4 +1,4 @@
-/*  $Id: xircom_pgs.S,v 1.1 2004/07/22 19:49:48 joff Exp $
+/*  $Id: xircom_pgs.S,v 1.2 2004/08/04 01:29:56 joff Exp $
  * 
  *  Firmware for the Keyspan PDA Serial Adapter, a USB serial port based on
  *  the EzUSB microcontroller.
Index: drivers/usb/serial/xircom_pgs_fw.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/serial/xircom_pgs_fw.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/serial/xircom_pgs_fw.h	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/serial/xircom_pgs_fw.h	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,8 +1,8 @@
 /*
  * USB Xircom PGS Firmware
  *
- * Copyright (c) 1999, 2000 Brian Warner        <warner@lothar.com>
- * Copyright (c) 2001 Cristian M. Craciunescu	<cristi@dnt.ro>
+ * Copyright (C) 1999, 2000 Brian Warner        <warner@lothar.com>
+ * Copyright (C) 2001 Cristian M. Craciunescu	<cristi@dnt.ro>
  *
  *      This program is free software; you can redistribute it and/or modify
  *      it under the terms of the GNU General Public License as published by
Index: drivers/usb/storage/datafab.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/datafab.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/datafab.c	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/datafab.c	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,6 +1,6 @@
 /* Driver for Datafab USB Compact Flash reader
  *
- * $Id: datafab.c,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: datafab.c,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * datafab driver v0.1:
  *
@@ -695,20 +695,24 @@
 	}
 
 	if (srb->cmnd[0] == READ_CAPACITY) {
+		unsigned int max_sector;
+
 		info->ssize = 0x200;  // hard coded 512 byte sectors as per ATA spec
 		rc = datafab_id_device(us, info);
 		if (rc != USB_STOR_TRANSPORT_GOOD)
 			return rc;
 
-		US_DEBUGP("datafab_transport:  READ_CAPACITY:  %ld sectors, %ld bytes per sector\n",
+		US_DEBUGP("datafab_transport:  READ_CAPACITY:  "
+			  "%ld sectors, %ld bytes per sector\n",
 			  info->sectors, info->ssize);
 
 		// build the reply
 		//
-		ptr[0] = (info->sectors >> 24) & 0xFF;
-		ptr[1] = (info->sectors >> 16) & 0xFF;
-		ptr[2] = (info->sectors >> 8) & 0xFF;
-		ptr[3] = (info->sectors) & 0xFF;
+		max_sector = info->sectors - 1;
+		ptr[0] = (max_sector >> 24) & 0xFF;
+		ptr[1] = (max_sector >> 16) & 0xFF;
+		ptr[2] = (max_sector >> 8) & 0xFF;
+		ptr[3] = (max_sector) & 0xFF;
 
 		ptr[4] = (info->ssize >> 24) & 0xFF;
 		ptr[5] = (info->ssize >> 16) & 0xFF;
Index: drivers/usb/storage/debug.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/debug.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/debug.c	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/debug.c	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,7 +1,7 @@
 /* Driver for USB Mass Storage compliant devices
  * Debugging Functions Source Code File
  *
- * $Id: debug.c,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: debug.c,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * Current development and maintenance by:
  *   (c) 1999-2002 Matthew Dharm (mdharm-usb@one-eyed-alien.net)
Index: drivers/usb/storage/debug.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/debug.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/debug.h	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/debug.h	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,7 +1,7 @@
 /* Driver for USB Mass Storage compliant devices
  * Debugging Functions Header File
  *
- * $Id: debug.h,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: debug.h,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * Current development and maintenance by:
  *   (c) 1999, 2000 Matthew Dharm (mdharm-usb@one-eyed-alien.net)
Index: drivers/usb/storage/dpcm.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/dpcm.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/dpcm.c	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/dpcm.c	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,6 +1,6 @@
 /* Driver for Microtech DPCM-USB CompactFlash/SmartMedia reader
  *
- * $Id: dpcm.c,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: dpcm.c,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * DPCM driver v0.1:
  *
Index: drivers/usb/storage/dpcm.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/dpcm.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/dpcm.h	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/dpcm.h	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,6 +1,6 @@
 /* Driver for Microtech DPCM-USB CompactFlash/SmartMedia reader
  *
- * $Id: dpcm.h,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: dpcm.h,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * DPCM driver v0.1:
  *
Index: drivers/usb/storage/freecom.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/freecom.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/freecom.c	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/freecom.c	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,6 +1,6 @@
 /* Driver for Freecom USB/IDE adaptor
  *
- * $Id: freecom.c,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: freecom.c,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * Freecom v0.1:
  *
Index: drivers/usb/storage/freecom.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/freecom.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/freecom.h	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/freecom.h	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,6 +1,6 @@
 /* Driver for Freecom USB/IDE adaptor
  *
- * $Id: freecom.h,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: freecom.h,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * Freecom v0.1:
  *
Index: drivers/usb/storage/initializers.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/initializers.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/initializers.c	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/initializers.c	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,6 +1,6 @@
 /* Special Initializers for certain USB Mass Storage devices
  *
- * $Id: initializers.c,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: initializers.c,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * Current development and maintenance by:
  *   (c) 1999, 2000 Matthew Dharm (mdharm-usb@one-eyed-alien.net)
@@ -39,6 +39,7 @@
 
 #include "initializers.h"
 #include "debug.h"
+#include "transport.h"
 
 /* This places the Shuttle/SCM USB<->SCSI bridge devices in multi-target
  * mode */
@@ -57,4 +58,51 @@
 	return 0;
 }
 
+/* This function is required to activate all four slots on the UCR-61S2B
+ * flash reader */
 
+int usb_stor_ucr61s2b_init(struct us_data *us)
+{
+	int pipe;
+	struct bulk_cb_wrap *bcb;
+	struct bulk_cs_wrap *bcs;
+	int res, partial;
+
+	bcb = kmalloc(sizeof *bcb, in_interrupt() ? GFP_ATOMIC : GFP_NOIO);
+	if (!bcb) {
+		return(-1);
+	}
+	bcs = kmalloc(sizeof *bcs, in_interrupt() ? GFP_ATOMIC : GFP_NOIO);
+	if (!bcs) {
+		kfree(bcb);
+		return(-1);
+	}
+
+	US_DEBUGP("Sending UCR-61S2B initialization packet...\n");
+
+	bcb->Signature = cpu_to_le32(US_BULK_CB_SIGN);
+	bcb->Tag = ++(us->tag);
+	bcb->DataTransferLength = cpu_to_le32(0);
+	bcb->Flags = bcb->Lun = 0;
+	bcb->Length = sizeof(UCR61S2B_INIT);
+	memset(bcb->CDB, 0, sizeof(bcb->CDB));
+	memcpy(bcb->CDB, UCR61S2B_INIT, sizeof(UCR61S2B_INIT));
+
+	pipe = usb_sndbulkpipe(us->pusb_dev, us->ep_out);
+	res = usb_stor_bulk_msg(us, bcb, pipe, US_BULK_CB_WRAP_LEN, &partial);
+	US_DEBUGP("-- result is %d\n", res);
+	kfree(bcb);
+
+	if(res) {
+		kfree(bcs);
+		return(res);
+	}
+
+	pipe = usb_rcvbulkpipe(us->pusb_dev, us->ep_in);
+	res = usb_stor_bulk_msg(us, bcs, pipe, US_BULK_CS_WRAP_LEN, &partial);
+	US_DEBUGP("-- result of status read is %d\n", res);
+
+	kfree(bcs);
+
+	return(res ? -1 : 0);
+}
Index: drivers/usb/storage/initializers.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/initializers.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/initializers.h	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/initializers.h	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,6 +1,6 @@
 /* Header file for Special Initializers for certain USB Mass Storage devices
  *
- * $Id: initializers.h,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: initializers.h,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * Current development and maintenance by:
  *   (c) 1999, 2000 Matthew Dharm (mdharm-usb@one-eyed-alien.net)
@@ -37,8 +37,19 @@
  * 675 Mass Ave, Cambridge, MA 02139, USA.
  */
 
+#include <linux/config.h>
 #include "usb.h"
 
 /* This places the Shuttle/SCM USB<->SCSI bridge devices in multi-target
  * mode */
 int usb_stor_euscsi_init(struct us_data *us);
+
+#ifdef CONFIG_USB_STORAGE_SDDR09
+int sddr09_init(struct us_data *us);
+#endif
+
+#define UCR61S2B_INIT "\xec\x0a\x06\x00$PCCHIPS"
+
+/* This function is required to activate all four slots on the UCR-61S2B
+ * flash reader */
+int usb_stor_ucr61s2b_init(struct us_data *us);
Index: drivers/usb/storage/isd200.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/isd200.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/isd200.c	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/isd200.c	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,6 +1,6 @@
 /* Transport & Protocol Driver for In-System Design, Inc. ISD200 ASIC
  *
- * $Id: isd200.c,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: isd200.c,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * Current development and maintenance:
  *   (C) 2001-2002 Björn Stenberg (bjorn@haxx.se)
Index: drivers/usb/storage/jumpshot.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/jumpshot.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/jumpshot.c	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/jumpshot.c	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,6 +1,6 @@
 /* Driver for Lexar "Jumpshot" Compact Flash reader
  *
- * $Id: jumpshot.c,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: jumpshot.c,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * jumpshot driver v0.1:
  *
Index: drivers/usb/storage/protocol.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/protocol.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/protocol.c	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/protocol.c	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,6 +1,6 @@
 /* Driver for USB Mass Storage compliant devices
  *
- * $Id: protocol.c,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: protocol.c,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * Current development and maintenance by:
  *   (c) 1999-2002 Matthew Dharm (mdharm-usb@one-eyed-alien.net)
@@ -53,6 +53,22 @@
 /***********************************************************************
  * Helper routines
  ***********************************************************************/
+ 
+static void * find_data_location(Scsi_Cmnd *srb)
+{
+	if (srb->use_sg) {
+		/*
+		 * This piece of code only works if the first page is
+		 * big enough to hold more than 3 bytes -- which is
+		 * _very_ likely.
+		 */
+		struct scatterlist *sg;
+
+		sg = (struct scatterlist *) srb->request_buffer;
+		return (void *) sg[0].address;
+	} else
+		return (void *) srb->request_buffer;
+}
 
 /* Fix-up the return data from an INQUIRY command to show 
  * ANSI SCSI rev 2 so we don't confuse the SCSI layers above us
@@ -65,21 +81,48 @@
 	if (srb->cmnd[0] != INQUIRY)
 		return;
 
-	US_DEBUGP("Fixing INQUIRY data to show SCSI rev 2\n");
+	/* oddly short buffer -- bail out */
+	if (srb->request_bufflen < 3)
+		return;
 
-	/* find the location of the data */
-	if (srb->use_sg) {
-		struct scatterlist *sg;
+	data_ptr = find_data_location(srb);
 
-		sg = (struct scatterlist *) srb->request_buffer;
-		data_ptr = (unsigned char *) sg[0].address;
-	} else
-		data_ptr = (unsigned char *)srb->request_buffer;
+	/* if it's already 2, bail */
+	if ((data_ptr[2] & 7) == 2)
+		return;
+
+	US_DEBUGP("Fixing INQUIRY data to show SCSI rev 2 - was %d\n",
+		data_ptr[2] & 7);
 
 	/* Change the SCSI revision number */
 	data_ptr[2] = (data_ptr[2] & ~7) | 2;
 }
 
+/*
+ * Fix-up the return data from a READ CAPACITY command. A Feiya reader
+ * returns a value that is 1 too large.
+ */
+static void fix_read_capacity(Scsi_Cmnd *srb)
+{
+	unsigned char *dp;
+	unsigned long capacity;
+
+	/* verify that it's a READ CAPACITY command */
+	if (srb->cmnd[0] != READ_CAPACITY)
+		return;
+
+	dp = find_data_location(srb);
+
+	capacity = (dp[0]<<24) + (dp[1]<<16) + (dp[2]<<8) + (dp[3]);
+	US_DEBUGP("US: Fixing capacity: from %ld to %ld\n",
+		capacity+1, capacity);
+	capacity--;
+	dp[0] = (capacity >> 24);
+	dp[1] = (capacity >> 16);
+	dp[2] = (capacity >> 8);
+	dp[3] = (capacity);
+}
+
 /***********************************************************************
  * Protocol routines
  ***********************************************************************/
@@ -194,6 +237,10 @@
 	 * a unsigned char cmnd[12], so we know we have storage available
 	 */
 
+	/* Pad the ATAPI command with zeros */
+	for (; srb->cmd_len<12; srb->cmd_len++)
+		srb->cmnd[srb->cmd_len] = 0;
+
 	/* set command length to 12 bytes (this affects the transport layer) */
 	srb->cmd_len = 12;
 
@@ -345,6 +392,10 @@
 
 		/* fix the INQUIRY data if necessary */
 		fix_inquiry_data(srb);
+
+		/* Fix the READ CAPACITY result if necessary */
+		if (us->flags & US_FL_FIX_CAPACITY)
+			fix_read_capacity(srb);
 	}
 }
 
Index: drivers/usb/storage/protocol.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/protocol.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/protocol.h	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/protocol.h	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,7 +1,7 @@
 /* Driver for USB Mass Storage compliant devices
  * Protocol Functions Header File
  *
- * $Id: protocol.h,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: protocol.h,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * Current development and maintenance by:
  *   (c) 1999, 2000 Matthew Dharm (mdharm-usb@one-eyed-alien.net)
@@ -57,6 +57,8 @@
 #define US_SC_MIN	US_SC_RBC
 #define US_SC_MAX	US_SC_ISD200
 
+#define US_SC_DEVICE	0xff		/* Use device's value */
+
 extern void usb_stor_ATAPI_command(Scsi_Cmnd*, struct us_data*);
 extern void usb_stor_qic157_command(Scsi_Cmnd*, struct us_data*);
 extern void usb_stor_ufi_command(Scsi_Cmnd*, struct us_data*);
Index: drivers/usb/storage/scsiglue.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/scsiglue.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/scsiglue.c	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/scsiglue.c	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,7 +1,7 @@
 /* Driver for USB Mass Storage compliant devices
  * SCSI layer glue code
  *
- * $Id: scsiglue.c,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: scsiglue.c,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * Current development and maintenance by:
  *   (c) 1999, 2000 Matthew Dharm (mdharm-usb@one-eyed-alien.net)
@@ -213,9 +213,14 @@
 static int device_reset( Scsi_Cmnd *srb )
 {
 	struct us_data *us = (struct us_data *)srb->host->hostdata[0];
+	int rc;
 
 	US_DEBUGP("device_reset() called\n" );
-	return us->transport_reset(us);
+
+	spin_unlock_irq(&io_request_lock);
+	rc = us->transport_reset(us);
+	spin_lock_irq(&io_request_lock);
+	return rc;
 }
 
 /* This resets the device port, and simulates the device
Index: drivers/usb/storage/scsiglue.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/scsiglue.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/scsiglue.h	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/scsiglue.h	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,7 +1,7 @@
 /* Driver for USB Mass Storage compliant devices
  * SCSI Connecting Glue Header File
  *
- * $Id: scsiglue.h,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: scsiglue.h,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * Current development and maintenance by:
  *   (c) 1999, 2000 Matthew Dharm (mdharm-usb@one-eyed-alien.net)
Index: drivers/usb/storage/sddr09.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/sddr09.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/sddr09.h	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/sddr09.h	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,7 +1,7 @@
 /* Driver for SanDisk SDDR-09 SmartMedia reader
  * Header File
  *
- * $Id: sddr09.h,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: sddr09.h,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * Current development and maintenance by:
  *   (c) 2000 Robert Baruch (autophile@dol.net)
Index: drivers/usb/storage/sddr55.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/sddr55.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/sddr55.c	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/sddr55.c	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,6 +1,6 @@
 /* Driver for SanDisk SDDR-55 SmartMedia reader
  *
- * $Id: sddr55.c,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: sddr55.c,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * SDDR55 driver v0.1:
  *
Index: drivers/usb/storage/sddr55.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/sddr55.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/sddr55.h	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/sddr55.h	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,7 +1,7 @@
 /* Driver for SanDisk SDDR-55 SmartMedia reader
  * Header File
  *
- * $Id: sddr55.h,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: sddr55.h,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * Current development and maintenance by:
  *   (c) 2002 Simon Munton
Index: drivers/usb/storage/shuttle_usbat.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/shuttle_usbat.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/shuttle_usbat.c	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/shuttle_usbat.c	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,6 +1,6 @@
 /* Driver for SCM Microsystems USB-ATAPI cable
  *
- * $Id: shuttle_usbat.c,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: shuttle_usbat.c,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * Current development and maintenance by:
  *   (c) 2000, 2001 Robert Baruch (autophile@starband.net)
Index: drivers/usb/storage/shuttle_usbat.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/usb/storage/shuttle_usbat.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/usb/storage/shuttle_usbat.h	22 Jul 2004 19:49:48 -0000	1.1
+++ drivers/usb/storage/shuttle_usbat.h	4 Aug 2004 01:29:56 -0000	1.2
@@ -1,7 +1,7 @@
 /* Driver for SCM Microsystems USB-ATAPI cable
  * Header File
  *
- * $Id: shuttle_usbat.h,v 1.1 2004/07/22 19:49:48 joff Exp $
+ * $Id: shuttle_usbat.h,v 1.2 2004/08/04 01:29:56 joff Exp $
  *
  * Current development and maintenance by:
  *   (c) 2000 Robert Baruch (autophile@dol.net)
